#pragma once
#include <iostream>
#include <string>
#include <map>
#include <algorithm>
#include <iomanip>

struct record {
	unsigned int number;
	unsigned int code;
	char name[50] = "";
	char date[50] = "";
	unsigned int expiration;
	unsigned int amount;
	double price_for_one;
	record() = default;
	record(unsigned int c_number, unsigned int p_code, const char* c_name, const char* c_creation_date, unsigned int c_expiration, unsigned int c_amount, double c_price_for_one) {
		number = c_number;
		code = p_code;
		strcpy_s(name, c_name);
		strcpy_s(date, c_creation_date);
		expiration = c_expiration;
		amount = c_amount;
		price_for_one = c_price_for_one;
	};

	bool operator == (const record& rec) const
	{
		return (number == rec.number && code == rec.code && strcmp(name, rec.name) == 0  && strcmp(date, rec.date) == 0 && expiration == rec.expiration && amount == rec.amount && price_for_one == rec.price_for_one);
	}
	friend std::ostream& operator <<(std::ostream& out, const record& rec);
	friend std::istream& operator >>(std::istream& in, record& rec);

};



class mainClass
{
private:
	std::map<size_t, record> records_map;
	size_t s;

	void load_in();
	void load_out();

public:
	mainClass();
	~mainClass();
	void add_record(record& p);
	bool search_record_number(const int p);
	bool search_record_code(const int p);
	bool search_record_date(const std::string& p);
	bool search_expiration(const int p);
	bool delete_record(const record& p);
	bool change_record(const record& p1, const record& p2);
	void load_out_txt();
};